//Include relevant libraries that the program will need
#include <math.h>
#include <Time.h>

//Constants to be used for voltage-temperature conversion
float A = 0.001129148;
float B = 0.000234125;
float C = 0.0000000876741;

//Function to convert measured voltage to temperature in fahrenheit
double voltageToTemp(int voltage) {

 double res;
 double temp;

 //res variable to hold the value of natural log of thermal resistance valu
 res = log(10000.0*((1024.0/voltage-1))); 
 
 /* Convert the thermal resistance value to temperature with equation
  * T=1/(A + Bln(R) + Cln(R)^3)
  */
 temp = 1 / (A + (B * res) + (C * res * res * res) );

 /* Convert the temp value from Kelvin to Celcius to Fahrenheit using equations:
  * Celcius = Kelvin - 273.15
  * Fahrenheit = ( (9.0/5.0) * Celcius ) + 32.0
  */
 //*INSERT CODE HERE*
 
 return temp;
}

void setup() {

 //Establishing a serial communication with baud rate 9600
 Serial.begin(9600);
 Serial.println("Time (s), Temperature (F)");
}

void loop() {
            
  int volt; 
  int times;                 
  double temperature;

  //Read values from pin A0 into variable volt
  //*INSERT CODE HERE*
  

  //Call voltage to temperature function for conversion
  temperature=voltageToTemp(volt);
  //Get time of running program, in milliseconds and convert to seconds
  times = millis()/1000; 
  
  Serial.print(times);
  Serial.print(", ");
  Serial.println(temperature);  
  delay(5000);
}

